import unittest

class Lean4Test(unittest.TestCase):
    def test_lean4(self):
        from itp_interface.rl.simple_proof_env import ProofEnv
        from itp_interface.rl.proof_action import ProofAction
        from itp_interface.tools.proof_exec_callback import ProofExecutorCallback
        from itp_interface.rl.simple_proof_env import ProofEnvReRankStrategy
        project_folder = "src/data/test/lean4_proj"
        file_path = "src/data/test/lean4_proj/Lean4Proj/Basic.lean"
        theorem_name = "test3"
        language = ProofAction.Language.LEAN4
        # theorem test3 (p q : Prop) (hp : p) (hq : q)
        # : p ∧ q ∧ p :=
        proof_exec_callback = ProofExecutorCallback(
            project_folder=project_folder,
            file_path=file_path,
            language=language,
            always_use_retrieval=False,
            keep_local_context=True
        )
        always_retrieve_thms = False
        retrieval_strategy = ProofEnvReRankStrategy.NO_RE_RANK
        env = ProofEnv("test_lean4", proof_exec_callback, theorem_name, retrieval_strategy=retrieval_strategy, max_proof_depth=10, always_retrieve_thms=always_retrieve_thms)
        proof_steps = [
            'apply And.intro',
            'exact hp',
            'apply And.intro',
            'exact hq',
            'exact hp'
        ]
        with env:
            state, _, next_state, reward, done, info = env.step(ProofAction(
                ProofAction.ActionType.RUN_TACTIC, 
                language, 
                tactics=[proof_steps[0]]))
            env.render() # Print the last state, next state, action and reward

def main():
    unittest.main()

if __name__ == '__main__':
    main()